/******************************************************************************
* Sdl Gui FrameWork (SGFW) : GUI Environment for SDL
* Copyright (C) 2007, Alexander Roper
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
* 
* Alexander Roper
* minirop@peyj.com
******************************************************************************/

#ifndef __GWIDGET_H__SGFW___200702232324____
#define __GWIDGET_H__SGFW___200702232324____

#include "GObject.h"
#include <vector>

class DECLSPEC GWidget : public GObject
{
public:
	GWidget(GWidget* = 0);
	virtual ~GWidget();
	virtual void update();
	void resize(int,int);
	void setPos(int,int);
	void setBackgroundColor(int,int,int);

protected:
	virtual void paint();
	SDL_Surface *surf;
	SDL_Rect pos;
	std::vector<GWidget*> child;
	GWidget *parent;
	SDL_Color bg;
};

#endif
