/******************************************************************************
* Sdl Gui FrameWork (SGFW) : GUI Environment for SDL
* Copyright (C) 2007, Alexander Roper
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
* 
* Alexander Roper
* minirop@peyj.com
******************************************************************************/

#include "SGFW.h"
#include <stdio.h>
#include <stdlib.h>
#include "GWidget.h"

SDL_Surface *__root_surface = 0;
SGFW* gApp = 0;

SGFW::SGFW()
{
	if(gApp != 0)
	{
		fprintf(stderr,"Il y a dj une instance de SGFW de cre\n");
		exit(1);
	}
	
	focused = 0;
	if(SDL_Init(SDL_INIT_VIDEO) == -1)
	{
		fprintf(stderr, "Erreur d'initialisation de la SDL : %s\n", SDL_GetError());
		exit(1);
	}
	else
	{
		ecran = SDL_SetVideoMode(800,600,32,SDL_SWSURFACE | SDL_DOUBLEBUF);
		if(ecran == NULL)
		{
			fprintf(stderr, "Impossible d'ouvrir une fentre\n");
			exit(1);
		}
		__root_surface = ecran;
	}
	gApp = this;
}

SGFW::~SGFW()
{
	SDL_Quit();
}

void SGFW::MainLoop()
{
	int continuer = 1;
	SDL_Event event;

	while (continuer)
	{
		SDL_WaitEvent(&event);
		switch(event.type)
		{
			case SDL_QUIT:
				continuer = 0;
				break;
		}
		for(std::vector<GWidget*>::iterator it = child.begin();it != child.end();++it)
		{
			(*it)->update();
		}
		SDL_Flip(__root_surface);
	}
}

void SGFW::AddChild(GWidget* c)
{
	child.push_back(c);
}
